/* Casnix OS 3 Kernel casnuz
*  Copyright (C) Matthew Caswell, 2011
*  The keyboard driver. */

#include <kbdus.h>
#include <monitor.h>
#include <kb.h>
#include <kernel_state.h>

int int01_flag=0;
int get_kb_ok=1;
int is_shift=0;
char getch_keys_gets()
{
          //the ascii char we want to return
	char ch;
	/* Make a while loop waiting for process to finish getting input */
          //this holds the scan code
	char scan_code;

          //label that might be used later
          wait_press:
			  int01_flag =0;
	  while(int01_flag == 0)
		  hlt();
         
	  int01_flag = 0;
         
          //store the scan code
	  scan_code=inb(0x60);

          //if the top bit is not set then return the character
	  if((scan_code&0x80)==0){
		                   if (!is_shift) ch = kbdus[ scan_code ];
		else
			ch=kbduss[ scan_code];
		  return ch;
	  }else{
                  //otherwise go back to waiting.
		  goto wait_press;
	  } 
} 
char getch_keys()
{
          //the ascii char we want to return
          char ch;

	  while((!get_kb_ok))
	  {
		  hlt();
	  }
          //this holds the scan code
          char scan_code;

          //label that might be used later
          wait_press:
	  get_kb_ok=0;	  
	  int01_flag =0;
          while(int01_flag == 0)
                     hlt();
         
          int01_flag = 0;
         
          //store the scan code
          scan_code=inb(0x60);

          //if the top bit is not set then return the character
	  
          if((scan_code&0x80)==0){
                  if (!is_shift) ch = kbdus[ scan_code ];
		else
			ch=kbduss[ scan_code];
		  get_kb_ok=1;
                  return ch;
          }else{
                  //otherwise go back to waiting.
                  goto wait_press;
          } 
} 

char *gets(char *buf)
{
	while((!get_kb_ok))
	{
		hlt();
	}
	get_kb_ok=0;
	int i;
	int c;
	buf[0] = '\0';
	i = 0;
	while (1) {
		c = getch_keys_gets();
		if (c == -'1')
			break;
		if (c == '\r' || c == '\n') {
			break;
		}
		if (c == '\b' || c == 0x7f) {
			if (i > 0) {
				i--;
				buf[i] = '\0';
			}
			continue;
		}
		buf[i++] = c;
	}
	buf[i] = '\0';
	get_kb_ok=1;
	return buf;
}

static void write_kbd(unsigned adr, unsigned data)
{
	unsigned long timeout;
	unsigned stat;

	/* Linux code didn't have a timeout here... */
	for(timeout = 500000L; timeout != 0; timeout--)
	{
		stat = inb(0x64);
		/* loop until 8042 input buffer empty */
		if((stat & 0x02) == 0)
			break;
	}
	if(timeout != 0)
		outb(adr, data);
}

unsigned convert(unsigned key)
{

	static unsigned short kbd_status, saw_break_code;

	unsigned char temp;

	/* check for break key (i.e. a key is released) */
	if(key >= 0x80)
	{
		saw_break_code = 1;
		key &= 0x7F;
	}
	/* the only break codes we're interested in are Shift, Ctrl, Alt */
	if(saw_break_code)
	{
		if(key == RAW1_LEFT_ALT || key == RAW1_RIGHT_ALT)
			kbd_status &= ~KBD_META_ALT;
		else if(key == RAW1_LEFT_CTRL || key == RAW1_RIGHT_CTRL)
			kbd_status &= ~KBD_META_CTRL;
		else if(key == RAW1_LEFT_SHIFT || key == RAW1_RIGHT_SHIFT)
			kbd_status &= ~KBD_META_SHIFT;
		saw_break_code = 0;
		return 0;
	}
	/* it's a make key: check the "meta" keys, as above */
	if(key == RAW1_LEFT_ALT || key == RAW1_RIGHT_ALT)
	{
		kbd_status |= KBD_META_ALT;
		return 0;
	}
	if(key == RAW1_LEFT_CTRL || key == RAW1_RIGHT_CTRL)
	{
		kbd_status |= KBD_META_CTRL;
		return 0;
	}
	if(key == RAW1_LEFT_SHIFT || key == RAW1_RIGHT_SHIFT)
	{
		kbd_status |= KBD_META_SHIFT;
		return 0;
	}
/* Scroll Lock, Num Lock, and Caps Lock set the LEDs. These keys
	have on-off (toggle or XOR) action, instead of momentary action */
	if(key == RAW1_SCROLL_LOCK)
	{
		kbd_status ^= KBD_META_SCRL;
		goto LEDS;
	}
	if(key == RAW1_NUM_LOCK)
	{
		kbd_status ^= KBD_META_NUM;
		goto LEDS;
	}
	if(key == RAW1_CAPS_LOCK)
	{
		kbd_status ^= KBD_META_CAPS;
		LEDS:		
		write_kbd(0x60, 0xED);	/* "set LEDs" command */
		temp = 0;
		if(kbd_status & KBD_META_SCRL)
			temp |= 1;
		if(kbd_status & KBD_META_NUM)
			temp |= 2;
		if(kbd_status & KBD_META_CAPS)
			temp |= 4;
		write_kbd(0x60, temp);	/* bottom 3 bits set LEDs */
		return 0;
	}
	/* ignore invalid scan codes */
	//if(key >= sizeof(set1_map) / sizeof(set1_map[0]))
	//	return 0;
	/* convert raw scancode in key to unshifted ASCII in temp */
	temp = kbdus[key];
	/* defective keyboard? non-US keyboard? more than 104 keys? */
	if(temp == 0)
		return temp;
	/* handle the three-finger salute */
	if((kbd_status & KBD_META_CTRL) && (kbd_status & KBD_META_ALT) && (temp == KEY_DEL))
	{
		puts("Just press the power button.");
	}
	if(kbd_status & KBD_META_SHIFT)
		is_shift=1;
	else
		is_shift=0;
	/* I really don't know what to do yet with Alt, Ctrl, etc. -- punt */
	return temp;
}

void kb_handler(registers_t *regs)
{
    unsigned char scancode;
    int01_flag=1;
    /* Read from the keyboard's data buffer */
    scancode = inb(0x60);

    /* If the top bit of the byte we read from the keyboard is
    *  set, that means that a key has just been released */
	convert(scancode);
    if (scancode & 0x80)
    {
        
    }
    else
    {
        if(!is_shift)putc(kbdus[scancode]);
	else putc(kbduss[scancode]);
	if(kbdus[scancode] == '\b')
	{
		puts(" \b");
		putc('\0');
	}
    }
}

void install_kb()
{
	register_interrupt_handler(IRQ1, &kb_handler);
}